// Dictionary.cpp : Defines the class behaviors for the application.
//
#include "stdafx.h"
#include "winreg.h" // for RegOpenKeyEx/RegQueryValueEx functions
#include "Dictionary.h"

#include "DictionaryDoc.h"
#include "MainFrm.h"

#include "RoundButton.h"
#include "DictionarySrchView.h"
#include "RegistryAnalizer.h"
#include "PaletteFromBmp.h"
#include "EvgenyFace.h"
//#include "Splash.h"
//#include "MyCmdLineInfo.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//CRegistryAnalizer Registry;  //Registry defined in RegistryAnalizer.cpp

Language	gLanguage;

/////////////////////////////////////////////////////////////////////////////
// CDictionaryApp

BEGIN_MESSAGE_MAP(CDictionaryApp, CWinApp)
	//{{AFX_MSG_MAP(CDictionaryApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDictionaryApp construction

CDictionaryApp::CDictionaryApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDictionaryApp object

CDictionaryApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDictionaryApp initialization

BOOL CDictionaryApp::InitInstance()
{
	// CG: The following block was added by the Splash Screen component.
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CDictionaryDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CDictionarySrchView));
	AddDocTemplate(pDocTemplate);
/*
	CSingleDocTemplate* pDocTemplate2;
	pDocTemplate2 = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CDictionaryDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CDictionarySrchView));
	AddDocTemplate(pDocTemplate2);
*/
	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	CString name;

	if(	Registry.GetValue(DEFAULT_DOCUMENT, name))
	{
		if(!OpenDocumentFile((LPCTSTR) name)) {
			OnFileNew();
		}
	}
	else
	{
		OnFileNew();
	}
	// Enable drag/drop open
	if(m_pMainWnd) {
		m_pMainWnd->DragAcceptFiles();
	}
	else return false; 

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog, public CEvgenyFace
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CRoundButton	m_ok;
	//}}AFX_DATA
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	afx_msg BOOL OnQueryNewPalette();
	CPalette* m_pPalette;
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD), CEvgenyFace( IDB_FACE )
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDOK, m_ok);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	ON_WM_CREATE()
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDictionaryApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// Evgeny Savitsky'97

void CAboutDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	// Do not call CDialog::OnPaint() for painting messages
	CEvgenyFace::Paint( &dc, this );
}

int CAboutDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
// const NumEntries = 236;
// int	j;
 
 m_pPalette = NULL;
	// CG: This function was added by the Palette Support component

	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
/*
	PLogPalette = (LOGPALETTE*)LocalAlloc(LPTR, sizeof(LOGPALETTE) +
                                              (NumEntries - 1) * sizeof(PALETTEENTRY));
	
	PLogPalette -> palVersion = 0x0300;
	PLogPalette -> palNumEntries = NumEntries;
 
	for(j = 0; j < NumEntries; j ++)
	{
		PLogPalette -> palPalEntry[j].peRed = 2 * j;
		PLogPalette -> palPalEntry[j].peGreen = j;
		PLogPalette -> palPalEntry[j].peBlue = 4 * j;
		PLogPalette -> palPalEntry[j].peFlags = 0x0000;
	}

*/	
/*	hFace = LoadResourceBitmap(AfxGetInstanceHandle(),
								MAKEINTRESOURCE(IDB_MYFACE), &hPalette);
	GetObject( hFace, sizeof(BITMAP), &bmpFace);

//	m_pPalette = new CPalette();
//	m_pPalette->CreatePalette( &hPalette );
*/
	CEvgenyFace::Initialize( m_pPalette );

	return 0;
}

BOOL CDictionaryApp::PreTranslateMessage(MSG* pMsg)
{
	// CG: The following line was added by the Splash Screen component.
//	CSplashWnd::PreTranslateAppMessage(pMsg);

	return CWinApp::PreTranslateMessage(pMsg);
}

