// ListBoxDict.cpp : implementation file
//

#include "stdafx.h"
#include "Dictionary.h"
#include "ListBoxDict.h"
#include "RegistryAnalizer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CRegistryAnalizer Registry;
/////////////////////////////////////////////////////////////////////////////
// CListBoxDict

CListBoxDict::CListBoxDict()
{

	m_hNewFont = NULL;
//#ifdef _ENGLISH_EDITION
/*	CString szFontName;
	LONG	lFontHeight;
	//COLORREF	rgbColor;

	Registry.GetValue( ENGLISH_FONT_NAME, szFontName );
	Registry.GetValue( ENGLISH_FONT_HEIGHT, (DWORD &) lFontHeight );
	Registry.GetValue( ENGLISH_FONT_COLOR, (DWORD &) m_colourRed );

	m_hNewFont = CreateFont(lFontHeight,0,0,0,FW_SEMIBOLD,
							0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,
							CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
							DEFAULT_PITCH | FF_DONTCARE,
							(LPCTSTR) szFontName );
//							"Comic Sans MS");
//#endif
/*
#ifdef _RUSSIAN_EDITION

	m_hNewFont = CreateFont(28,0,0,0,FW_SEMIBOLD,
							0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,
							CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
							DEFAULT_PITCH | FF_DONTCARE,
							"Arial Cyr");
//							"Comic Sans MS");
#endif
*/
/*	if( m_hNewFont == NULL )
		m_hNewFont = (HFONT)::GetStockObject(SYSTEM_FONT);

//	m_engColor = RGB(255,0,0);
//	m_colourRed = RGB(255,0,0);
	m_colourSelected = RGB(0,0,250);
	//	CDC* pDC = GetDC();
*/
}

CListBoxDict::~CListBoxDict()
{
	if(m_hNewFont)
		::DeleteObject( m_hNewFont );
}

/*
BEGIN_MESSAGE_MAP(CListBoxDict, CListBox)
	//{{AFX_MSG_MAP(CListBoxDict)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
*/
/////////////////////////////////////////////////////////////////////////////
// CListBoxDict message handlers

void CListBoxDict::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
//	lpMeasureItemStruct->itemWidth = 100;
	if(lpMeasureItemStruct->itemID == ((UINT) -1)) 
		return;

	CString str;
	CListBox::GetText( lpMeasureItemStruct->itemID , str );
	CDC* pDC = GetDC();
	RECT rect;

	GetClientRect(&rect);

//	CFont *pFont = pDC->SelectObject(CFont::FromHandle(m_hNewFont));

//	lpMeasureItemStruct->itemHeight += pDC->
//		DrawText( str, &rect, 
//		DT_CALCRECT | DT_SINGLELINE);

	lpMeasureItemStruct->itemHeight += m_iNewFontHeight;

//	pDC->SelectObject(pFont);

	rect.right -= 10;

	lpMeasureItemStruct->itemHeight += pDC->
		DrawText( m_map[str], &rect, 
		DT_CALCRECT | DT_WORDBREAK | DT_LEFT);
}

void CListBoxDict::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	if(lpDrawItemStruct->itemID == ((UINT) -1)) 
		return;

	CDC* pDC = CDC::FromHandle( lpDrawItemStruct->hDC );
	
	CString str;
	
	int curSel = GetCurSel();
	//  
	if( curSel != LB_ERR )
	{
		// ,     
		// 
		if( lpDrawItemStruct->itemID == (unsigned)curSel )
			//    
			m_engColor = m_colourSelected ;
	}
	
	//,   
	switch( lpDrawItemStruct->itemAction ) 
	{
	//     ,  
	//
	case ODA_SELECT:
		if( lpDrawItemStruct->itemState != ODS_SELECTED )
			//  .
			m_engColor = m_colourRed ;
		break;
	
	//   
	case ODA_DRAWENTIRE:
		m_engColor = m_colourRed ;
		break;
	case ODA_FOCUS:
//			dc->Ellipse( 0,0,50,50 );
		break;
	}
	CListBox::GetText( lpDrawItemStruct->itemID , str );
	
	//    ,    
	CFont *pFont = pDC->SelectObject( CFont::FromHandle(m_hNewFont));
	pDC->SetTextColor( m_engColor );

	pDC->TextOut( lpDrawItemStruct->rcItem.left + 10,
				 lpDrawItemStruct->rcItem.top,
				 str);

	pDC->SelectObject(pFont);
	//   
	pDC->SetTextColor( RGB(0,0,0) );

	RECT rect = {lpDrawItemStruct->rcItem.left + 15,
				 lpDrawItemStruct->rcItem.top + m_iNewFontHeight + 2,
				 lpDrawItemStruct->rcItem.right - 15,
				 lpDrawItemStruct->rcItem.bottom};
	pDC->DrawText(m_map[str], &rect, DT_LEFT | DT_WORDBREAK);
}

int		CListBoxDict::AddString( CString& string1, CString& string2 )
{
	m_map[string1] = string2;
	return CListBox::AddString(string1);
}

int		CListBoxDict::InsertString( int index, CString& string1, CString& string2 )
{
	m_map[string1] = string2;
	return CListBox::InsertString( index, string1);
}


void CListBoxDict::PreSubclassWindow() 
{
	CListBox::PreSubclassWindow();
}

int CListBoxDict::CompareItem(LPCOMPAREITEMSTRUCT lpCompareItemStruct) 
{
	// TODO: Add your code to determine the sorting order of the specified items
	// return -1 = item 1 sorts before item 2
	// return 0 = item 1 and item 2 sort the same
	// return 1 = item 1 sorts after item 2
	//int a = 1;
	
	return 1;
}

void CListBoxDict::ResetContent()
{
	CListBox::ResetContent();

	//  ,    
	if( m_hNewFont )
	{
		::DeleteObject( m_hNewFont );
		m_hNewFont = NULL;
	}

	CString szFontName;
	LONG	lFontHeight;

	//      s
	Registry.GetValue( ENGLISH_FONT_NAME, szFontName );
	Registry.GetValue( ENGLISH_FONT_HEIGHT, (DWORD &) lFontHeight );
	Registry.GetValue( ENGLISH_FONT_COLOR, (DWORD &) m_colourRed );

	m_hNewFont = CreateFont(lFontHeight,0,0,0,FW_SEMIBOLD,
							0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,
							CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
							DEFAULT_PITCH | FF_DONTCARE,
							(LPCTSTR) szFontName );

	if( m_hNewFont == NULL )
		m_hNewFont = (HFONT)::GetStockObject(SYSTEM_FONT);

	m_colourSelected = RGB(0,0,250);

	//      
	CDC *pDC = GetDC();

	CFont *pOldFnt = pDC->SelectObject(CFont::FromHandle( m_hNewFont ));

	TEXTMETRIC tm;
	pDC->GetTextMetrics( &tm );
	m_iNewFontHeight = tm.tmHeight;
	
	//     
	pDC->SelectObject( pOldFnt );

	ReleaseDC( pDC );
}

CString CListBoxDict::GetText(int nIndex)
{
	CString some;
	CListBox::GetText(nIndex, some);
	return some;
}
