// Preferences.cpp : implementation file
//

#include "stdafx.h"
#include "DicProp.h"
//#include "Dictionary.h"
#include "Preferences.h"
#include "SettingsDlg.h"
#include "MainPrefDlg.h"
#include "StudyPrefDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//__gPreferences	gPreferences;
/////////////////////////////////////////////////////////////////////////////
// CPreferences dialog


CPreferences::CPreferences(CWnd* pParent /*=NULL*/)
	: CDialog(CPreferences::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPreferences)
	//}}AFX_DATA_INIT
	// Initializing variables
	for( int i = 0; i < DLG_NUM; i++ )
		m_pDlg[i] = NULL;

	m_lastSel = 0;
}

/////////////////////////////////////////////////////////////////////////////
// Standard destructor
CPreferences::~CPreferences(void)   
{
	for( int i = 0; i < DLG_NUM; i++ )
		if( m_pDlg[i] != NULL )
		{
			m_pDlg[i]->DestroyWindow();
			delete m_pDlg[i];
		}
}


void CPreferences::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPreferences)
	DDX_Control(pDX, IDC_PREF_TAB, m_PrefTabs);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPreferences, CDialog)
	//{{AFX_MSG_MAP(CPreferences)
	ON_NOTIFY(TCN_SELCHANGE, IDC_PREF_TAB, OnSelChangeOfPrefTab)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPreferences message handlers

void CPreferences::OnSelChangeOfPrefTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	//    
	int curSel = m_PrefTabs.GetCurSel();
	//     
	if (( curSel < 0 ) | (curSel > DLG_NUM))
		return;

	if ( curSel != m_lastSel )
		m_pDlg[ m_lastSel ]->ShowWindow(SW_HIDE);
	
	if ( m_pDlg[ curSel ] != NULL )
	{
		InsertDialogToTab( curSel );
		m_lastSel = curSel;
	}

	*pResult = 0;
}

BOOL CPreferences::OnInitDialog() 
{
	CDialog::OnInitDialog();
/*
	// Dialogs initializing
	m_pDlg[0] = new CMainPrefDlg( &m_PrefTabs );
	if( m_pDlg[0] == NULL )
	{
//		MessageBox( "Not enought memory! (CMainPrefDlg)", "Memory error...", MB_OK );
#ifdef _ENGLISH_EDITION
			ReportError( "Not enought memory!" );
#endif
#ifdef _RUSSIAN_EDITION
			ReportError( "  !" );
#endif
		return FALSE;
	}

//	if( !gPreferences.bIsStudyMode )	//      
	m_pDlg[1] = new CSettingsDlg( &m_PrefTabs );
	if( m_pDlg[1] == NULL )
	{
//		MessageBox( "Not enought memory! (CSettingsDlg)", "Memory error...", MB_OK );
#ifdef _ENGLISH_EDITION
			ReportError( "Not enought memory!" );
#endif
#ifdef _RUSSIAN_EDITION
			ReportError( "  !" );
#endif
		return FALSE;
	}

	m_pDlg[2] = new CStudyPrefDlg( &m_PrefTabs );
	if( m_pDlg[2] == NULL )
	{
//		MessageBox( "Not enought memory! (CStudyPrefDlg)", "Memory error...", MB_OK );
#ifdef _ENGLISH_EDITION
			ReportError( "Not enought memory!" );
#endif
#ifdef _RUSSIAN_EDITION
			ReportError( "  !" );
#endif
		return FALSE;
	}
*/
	// Initializing of Tab Control
	TC_ITEM tci;

	tci.mask = TCIF_TEXT | TCIF_IMAGE;
//	tci.iImage	=	-1;
/*
	tci.pszText	=	"Main";
	m_PrefTabs.InsertItem( 0, &tci );
*/
	//CImageList imageList;
	m_imageList.Create( 16, 16, TRUE, 0, 3);
/*	HICON hIcn = (HICON) LoadImage(hModule,
									MAKEINTRESOURCE(IDI_ICON_WINSTART),
									IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);

*/	
//	HICON hIcn = LoadIcon(
//	HICON hIcn = ;
	m_imageList.Add( AfxGetApp()->LoadIcon(IDI_ICON_PROGRAM));
	m_imageList.Add( AfxGetApp()->LoadIcon(IDI_ICON_WINSTART));
	m_imageList.Add( AfxGetApp()->LoadIcon(IDI_ICON_STUDING));
	
	m_PrefTabs.SetImageList( &m_imageList );
	m_PrefTabs.SetPadding(CSize( 7, 5 ));

#ifdef _ENGLISH_EDITION
	tci.iImage = 0;
	tci.pszText	=	"Program";
	m_PrefTabs.InsertItem( 0, &tci );

	tci.iImage = 2;
	tci.pszText	=	"Studing";
	m_PrefTabs.InsertItem( 2, &tci );

	tci.iImage = 1;
	tci.pszText	=	"Windows95 Start";
	m_PrefTabs.InsertItem( 1, &tci );
#endif
#ifdef _RUSSIAN_EDITION
	tci.iImage = 0;
	tci.pszText	=	"";
	m_PrefTabs.InsertItem( 0, &tci );

	tci.iImage = 2;
	tci.pszText	=	"";
	m_PrefTabs.InsertItem( 2, &tci );

	tci.iImage = 1;
	tci.pszText	=	" Windows95";
	m_PrefTabs.InsertItem( 1, &tci );
#endif

	//   
//	InsertDialogToTab( 0 );
//	m_PrefTabs.SetCurSel( 0 );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPreferences::InsertDialogToTab( int curSel )
{
	RECT itemRect;
	//    
	m_PrefTabs.GetClientRect( &itemRect );
	//    
	m_PrefTabs.AdjustRect( FALSE, &itemRect );
	//   
	m_pDlg[ curSel ]->SetWindowPos( &wndTop, itemRect.left, itemRect.top,
									0, 0, SWP_SHOWWINDOW | SWP_NOSIZE );
}

void CPreferences::OnOK() 
{
	for( int i = 0; i < DLG_NUM; i++ )
		if( m_pDlg[i] != NULL )
			m_pDlg[i]->SendMessage(WM_SAVESETTINGS, 0, 0);

	CDialog::OnOK();
}
