//=======================================================================
// CRegistryAnalizer implementation
//

#include "stdafx.h"
#include "winreg.h"
#include "RegistryAnalizer.h"
//#include "Dictionary.h"
//#include "MyCmdLineInfo.h"

//extern CMyCmdLineInfo cmdInfo;
//extern __gPreferences	gPreferences;
CRegistryAnalizer Registry;

//  
int CRegistryAnalizer::m_nCopy = 0;

///////////////////////////////////////////////////////////////////////////////
CRegistryAnalizer::CRegistryAnalizer(void)
{
//	m_bUM = m_bWWM = FALSE;
//	m_bDocPresent = FALSE;
//	m_bWWMode = FALSE;
//	m_bUMode = FALSE;
//	m_iStudyMode = -1;

//	m_iStudyDlgPeriod = 5;
	if( m_nCopy == 0 )
	{
		m_nCopy++;	//  -  

		Analyze();
	}
	else
	{
		AfxThrowMemoryException();
		delete this;
	}
}

///////////////////////////////////////////////////////////////////////////////
CRegistryAnalizer::~CRegistryAnalizer(void)
{
	RegCloseKey(m_hDocKey);
	RegCloseKey(m_hWinRunKey);

	m_nCopy--;
}

///////////////////////////////////////////////////////////////////////////////
void CRegistryAnalizer::Analyze(void)
{
//	HKEY hKey;
	LONG rVal = 0L;
	DWORD size = _MAX_PATH;
//	unsigned char szText[sizeof(size)];

	//     
/*
	if( RegOpenKeyEx(HKEY_CLASSES_ROOT,
	 				 "Dictionary.Document\\DefaultDocument",
					 NULL,KEY_ALL_ACCESS, &m_hDocKey) != ERROR_SUCCESS)
		RegFatalError();
	*/
//try
//{
	if( RegOpenKeyEx(HKEY_CLASSES_ROOT,
	 				 KEYNAME_OPTIONS,
					 NULL,KEY_ALL_ACCESS, &m_hOptions) != ERROR_SUCCESS)
		//throw CRegException(KEYNAME_OPTIONS);
		RegFatalError(KEYNAME_OPTIONS);

	//        Windows
	if( RegOpenKeyEx(HKEY_LOCAL_MACHINE,
							KEYNAME_WIN95_START,
							NULL,KEY_ALL_ACCESS, &m_hWinRunKey) != ERROR_SUCCESS)
//		throw CRegException(KEYNAME_WIN95_START);
		RegFatalError(KEYNAME_WIN95_START);
	
/*
	if( (RegOpenKeyEx(HKEY_CLASSES_ROOT,
							"Dictionary.Document\\DefaultDocument",NULL,
							KEY_READ, &hKey) == ERROR_SUCCESS))*/

	// Open document at startup
/*
	rVal = 	RegQueryValueEx(m_hDocKey,NULL,NULL,NULL,
							m_szDocName, &size);
	*/
/*	rVal = 	RegQueryValueEx(m_hOptions,"DefaultDocument",NULL,NULL,
							m_szDocName, &size);

	if( size > 1L && (rVal == ERROR_SUCCESS) )
		m_bDocPresent = TRUE;
	else
	// a document name had not written 
		m_bDocPresent = FALSE;
*/	

	// Load Dictionary at Windows startup
/*
	if( (RegOpenKeyEx(HKEY_LOCAL_MACHINE,
							"Software\\Microsoft\\Windows\\CurrentVersion\\Run",
							NULL,KEY_READ, &hKey) == ERROR_SUCCESS))
	{
	*/

	// Load Dictionary at Windows startup
	if( RegQueryValueEx(m_hWinRunKey,"dictionary.exe",NULL,NULL,
								NULL, NULL) == ERROR_SUCCESS)
		m_bAtStartup = TRUE;
	else
		m_bAtStartup = FALSE;
/*
}

catch( CRegException E)
{
	E.ReportError();
	throw;

	return;
}
*/
/*	if( cmdInfo.m_bWWMode )
	{
		m_bWWMode = TRUE;
		m_bUMode = FALSE;
	}
	else
		if( cmdInfo.m_bUM )
		{
			m_bWWMode = FALSE;
			m_bUMode = TRUE;
		}
*/
	//        "Study"
/*	DWORD period = 0;
	size = sizeof(DWORD);
	//   
	rVal = 	RegQueryValueEx(m_hOptions,"StudyFullWindowDlgShowPeriod",NULL,NULL,
							(BYTE*) &period, &size);
	
	if( rVal == ERROR_SUCCESS )
		m_iStudyFWDlgPeriod = period;
	else
		m_iStudyFWDlgPeriod = 5;
	
	//   
	rVal = 	RegQueryValueEx(m_hOptions,"StudyUnobsessionDlgShowPeriod",NULL,NULL,
							(BYTE*) &period, &size);
	
	if( rVal == ERROR_SUCCESS )
		m_iStudyUODlgPeriod = period;
	else
		m_iStudyUODlgPeriod = 5;

	//     Win95
	int mode;
	size = sizeof( int );
	if(	RegQueryValueEx(m_hOptions,"StudyModeOnStart",NULL,NULL,
						(BYTE*) &mode, &size) == ERROR_SUCCESS )
//		if( mode != -1 )	//   
//		{
//			gPreferences.bIsStudyMode = TRUE;
//			gPreferences.iCurrentStudyMode = m_iStudyMode = mode;
			m_iStudyMode = mode;
//		}
*/
}

///////////////////////////////////////////////////////////////////////////////
void CRegistryAnalizer::RegFatalError(const char* str)
{
//	AfxMessageBox("Couldn't access the registry information!\n"
//				  "Please, reinstall Dictionary", MB_ICONEXCLAMATION);

	CString error_name = str;

	AfxMessageBox(	"Please, reinstall Dictionary !\n\n"
					"Can't access the registry information in section:\n"
					+ error_name, MB_ICONEXCLAMATION);
//	throw CException();
//	exit(0);
//	ExitProcess(0);
}

///////////////////////////////////////////////////////////////////////////////
void CRegistryAnalizer::RegRunAtStartup(BOOL wwm) /* TRUE - WWM, FALSE - UM */
{
//	char pathBuff[_MAX_PATH] = "\x0";
	CString szWordSpyPath;
	if(GetValue(WORD_SPY_PATH, szWordSpyPath)) {
		if(RegSetValueEx(m_hWinRunKey,"WordSpy.exe",NULL,
			 REG_SZ,(unsigned char*) (LPCSTR) szWordSpyPath,
			 szWordSpyPath.GetLength()) != ERROR_SUCCESS) 
		{
			RegFatalError(KEYNAME_WIN95_START);
			return;
		}
	}
	m_bAtStartup = TRUE;
}

///////////////////////////////////////////////////////////////////////////////
void CRegistryAnalizer::UnRegRunAtStartup(void)
{
	RegDeleteValue(m_hWinRunKey, "WordSpy.exe");
	m_bAtStartup = FALSE;
}


///////////////////////////////////////////////////////////////////////////////
BOOL	CRegistryAnalizer::SetValue( const char* szKeyName, DWORD value )
{
	if( m_hOptions )
	{
		if( RegSetValueEx(m_hOptions, szKeyName, NULL,
							 REG_DWORD,( BYTE *) &value,
							 sizeof( DWORD )) == ERROR_SUCCESS)
			return TRUE;

//		throw CRegException(szKeyName);
		RegFatalError(szKeyName);
	}
return FALSE;
}

///////////////////////////////////////////////////////////////////////////////
BOOL	CRegistryAnalizer::SetValue( const char* szKeyName, CString value )
{
	if( m_hOptions )
	{
		if(RegSetValueEx(m_hOptions, szKeyName, NULL, REG_SZ,
						(unsigned char*)(LPCTSTR) value,
						value.GetLength()) == ERROR_SUCCESS)
			return TRUE;

//		throw CRegException(szKeyName);
		RegFatalError(szKeyName);
	}
return FALSE;
}

///////////////////////////////////////////////////////////////////////////////
BOOL	CRegistryAnalizer::GetValue( const char* szKeyName, DWORD& value )
{
	DWORD	size = sizeof(DWORD);

	if( m_hOptions )
	{
		if(	RegQueryValueEx(m_hOptions, szKeyName,
								NULL,NULL,
								(BYTE*) &value, &size) == ERROR_SUCCESS )
			return TRUE;

//		throw CRegException(szKeyName);
		RegFatalError(szKeyName);
	}
return FALSE;
}

///////////////////////////////////////////////////////////////////////////////
BOOL	CRegistryAnalizer::GetValue( const char* szKeyName, CString& value )
{
	if( m_hOptions )
	{
		return GetValue(m_hOptions, szKeyName, value);
	}
	return FALSE;
}
/////////////////////////////////////////////////////////////////////////////
// Evgeny Savitsky'97

BOOL CRegistryAnalizer::GetValue(HKEY hKey, LPCSTR szKeyName, CString & value)
{
	DWORD size = _MAX_PATH;
	unsigned char text[_MAX_PATH] = "\x0";

	if( (RegQueryValueEx(hKey, szKeyName, NULL, NULL,
			 text, &size) == ERROR_SUCCESS) && ( size >= 1L ))
		{
			value = text;
			return TRUE;
		}
		RegFatalError(szKeyName);
	return FALSE;
}


BOOL CRegistryAnalizer::GetValue(HKEY hMainKey, LPCSTR szKeyName, LPCSTR szRegValue, CString &value)
{
	DWORD size = _MAX_PATH;
	HKEY hLocalKey;
	unsigned char text[_MAX_PATH] = "\x0";

	if( RegOpenKeyEx(hMainKey, szKeyName, NULL, KEY_READ, &hLocalKey) == ERROR_SUCCESS)
		if( (RegQueryValueEx(hLocalKey, szRegValue, NULL, NULL,
			 text, &size) == ERROR_SUCCESS) && ( size >= 1L ))
		{
			value = text;
			return TRUE;
		}

	RegFatalError(szKeyName);
	return FALSE;
}

