// RoundButton.cpp : implementation file
//

#include "stdafx.h"
#include "Dictionary.h"
#include "RoundButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRoundButton

CRoundButton::CRoundButton()
{
	DWORD  shadow = GetSysColor(COLOR_3DDKSHADOW),
		   hilight = GetSysColor(COLOR_3DHILIGHT),
		   face = GetSysColor(COLOR_3DFACE);

	m_brDark.CreateSolidBrush(shadow);
	m_brHiLight.CreateSolidBrush(hilight);
	m_brFace.CreateSolidBrush(face);

	m_penDark.CreatePen(PS_SOLID,0,shadow);
	m_penHiLight.CreatePen(PS_SOLID,0,hilight);
	m_penFace.CreatePen(PS_SOLID,0,face);
}

CRoundButton::~CRoundButton()
{
}


BEGIN_MESSAGE_MAP(CRoundButton, CButton)
	//{{AFX_MSG_MAP(CRoundButton)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRoundButton message handlers

void CRoundButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	if( lpDrawItemStruct->CtlType == ODT_BUTTON )
	{
		CDC  someDC;
		CDC* dc = someDC.FromHandle( lpDrawItemStruct->hDC );

		CBrush *oldBrush = dc->GetCurrentBrush();
		CPen   *oldPen = dc->GetCurrentPen();

//		LONG textX,textY;
		RECT rDark,rLight,rFace;

		rLight = rDark = rFace = lpDrawItemStruct->rcItem;

		CString str;
		GetWindowText(str);


		switch( lpDrawItemStruct->itemAction )
		{
		case ODA_DRAWENTIRE:
		
			DrawButtonFace( *dc, lpDrawItemStruct->rcItem );

//			textX = m_textX;
//			textY = m_textY;
					
			switch ( lpDrawItemStruct->itemState )
			{
			case ODS_DISABLED:
				dc->SetTextColor(GetSysColor(COLOR_3DHILIGHT));
				break;
			}
			break;

		case ODA_SELECT:
			switch ( lpDrawItemStruct->itemState )
			{
			case ODS_FOCUS:

				DrawButtonFace( *dc, lpDrawItemStruct->rcItem );
				DrawButtonFocus( dc, lpDrawItemStruct);

//				textX = m_textX;
//				textY = m_textY;
				break;

			case ODS_FOCUS | ODS_SELECTED:

				rFace.right -= 1;
				rFace.bottom -= 1;
				rFace.top += 3;
				rFace.left += 3;

				dc->SelectObject( &m_brDark );
				dc->SelectObject( &m_penDark );
				dc->Ellipse( &rDark );
				
				dc->SelectObject( &m_brFace );
				dc->SelectObject( &m_penFace );
				dc->Ellipse( &rFace );

				dc->SetTextColor( RGB( 0,0,150 ) );

				lpDrawItemStruct->rcItem.left += 1;
				lpDrawItemStruct->rcItem.top += 1;
//				textX = m_textX + 1;
//				textY = m_textY + 1;
				break;
			}
			break;

		case ODA_FOCUS:
		
			DrawButtonFocus( dc, lpDrawItemStruct);

			dc->SetTextColor( GetSysColor(COLOR_ACTIVECAPTION));

//			textX = m_textX;
//			textY = m_textY;
			break;
		}

//		dc->TextOut( textX,
//					 textY,str);
		dc->DrawText( str, &lpDrawItemStruct->rcItem, DT_CENTER | DT_VCENTER | 
			DT_SINGLELINE);

		dc->SelectObject( oldBrush );
		dc->SelectObject( oldPen );

	}
}

void CRoundButton::PreSubclassWindow() 
{
	CButton::PreSubclassWindow();
/*
	RECT rect;
	GetClientRect( &rect );


	CDC *pDC = GetDC();
	SIZE	fontSize;
	CString str;
	GetWindowText(str);

	GetTextExtentPoint32( pDC->GetSafeHdc(), str, str.GetLength()-3,
							&fontSize );


	m_textX = ((rect.right - rect.left) -
			    fontSize.cx ) / 2;

	m_textY = ((rect.bottom - rect.top) / 2) -
			   ( fontSize.cy / 2);

	ReleaseDC( pDC );
*/	
}

BOOL CRoundButton::DrawButtonFace( CDC &dc, RECT &rect )
{
	RECT rDark,rLight,rFace;

	rLight = rDark = rFace = rect;

	rFace.right -= 2;
	rFace.bottom -= 2;
	rFace.top += 2;
	rFace.left += 2;
		
	rLight.right -= 2;
	rLight.bottom -= 2;

	rDark.top += 2;
	rDark.left += 2;


	dc.SelectObject( &m_brDark );
	dc.SelectObject( &m_penDark );
	dc.Ellipse( &rDark );

	dc.SelectObject( &m_brHiLight );
	dc.SelectObject( &m_penHiLight );
	dc.Ellipse( &rLight );

	dc.SelectObject( &m_brFace );
	dc.SelectObject( &m_penFace );
	dc.Ellipse( &rFace );
//		break;
	dc.SetTextColor( GetSysColor(COLOR_ACTIVECAPTION));

	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////////
//    
void CRoundButton::DrawButtonFocus( CDC* pDC, LPDRAWITEMSTRUCT lpDIS )
{
	if( lpDIS->itemState == ODS_FOCUS )
	{
		pDC->SelectObject( &m_brFace );
	
		CPen dotPen( PS_DOT, 1, RGB( 0, 0, 0) );
		pDC->SelectObject( &dotPen );
	}
	else
	{
		CPen dotPen( PS_DOT, 1, GetSysColor(COLOR_3DFACE));
		pDC->SelectObject( &dotPen );
	}
	RECT rTab = lpDIS->rcItem;
	rTab.left += 3;	rTab.right -= 4; rTab.top += 3;	rTab.bottom -= 4;

	pDC->Ellipse( &rTab );
}
