// PictureButton.cpp : implementation file
//

#include "stdafx.h"
#include "wordspy.h"
#include "PictureButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPictureButton

CPictureButton::CPictureButton(UINT idBitmap, CSize &size)
{
	m_bitmap.LoadBitmap(idBitmap);
	m_bitmapSize = size;
	m_bIsFired = false;
	m_bIsUpdated = false;
	m_what = 0;
}

CPictureButton::~CPictureButton()
{
}


BEGIN_MESSAGE_MAP(CPictureButton, CButton)
	//{{AFX_MSG_MAP(CPictureButton)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_NCHITTEST()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPictureButton message handlers
void CPictureButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	
	pDC->BitBlt(0, 0, m_bitmapSize.cx, m_bitmapSize.cy, 
		&m_vDC, m_what * m_bitmapSize.cx, 0, SRCCOPY);
/*
	if(true)
	{
		CDC someDC;

		someDC.CreateCompatibleDC(&m_vDC);
		someDC.SelectObject(m_bitmap);

		m_vDC.BitBlt(0, 0, m_bitmapSize.cx, m_bitmapSize.cy,
			&someDC, 0, 0, SRCCOPY);

//		Invalidate();

		m_bIsUpdated = true;
	}
*/
}

void CPictureButton::Fire(bool bOn)
{
	if( (!m_bIsFired && bOn) || (m_bIsFired && !bOn)) {

		if(bOn) {	// 
			m_what = 2;
			m_bIsFired = true;

			SetCapture();
		}
		else {		// 
			m_what = 0;
			m_bIsFired = false;

			ReleaseCapture();
		}

//		m_vDC.BitBlt(0, 0, m_bitmapSize.cx, m_bitmapSize.cy,
//			&someDC, m_bitmapSize.cx * what, 0, SRCCOPY);
		Invalidate();
	}
}

void CPictureButton::PreSubclassWindow() 
{
	CButton::PreSubclassWindow();

	m_vDC.CreateCompatibleDC(GetDC());
	m_vDC.SelectObject(m_bitmap);

	SetWindowPos( &wndTop, 0, 0, m_bitmapSize.cx, m_bitmapSize.cy,
		SWP_NOMOVE);
}

void CPictureButton::OnMouseMove(UINT nFlags, CPoint point) 
{
//	ClientToScreen(&point);
	CRect rect;
	GetClientRect(rect);

	if(rect.PtInRect(point)) {
		Fire(true);
	}
	else
		Fire(false);
	
	CButton::OnMouseMove(nFlags, point);
}

void CPictureButton::OnLButtonDown(UINT nFlags, CPoint point) 
{
	//ReleaseCapture();
	//Fire(false);
	m_bIsFired = false;
//	CRect rect;
//	GetClientRect(rect);

//	if(rect.PtInRect(point)) {
//		ReleaseCapture();
//	}

	m_what = 1;
	Invalidate();
	
	CButton::OnLButtonDown(nFlags, point);
}

void CPictureButton::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_what = 2;
	Invalidate();
	
	CButton::OnLButtonUp(nFlags, point);
}

UINT CPictureButton::OnNcHitTest(CPoint point) 
{
	UINT result = CButton::OnNcHitTest(point);
	return result;
}
