// WordSpyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PictureButton.h"
#include "WordSpy.h"
#include "taskbar.h"
#include "WordSpyDlg.h"
#include "..\RegistryAnalizer.h"


#include "process.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

Language gLanguage;
/////////////////////////////////////////////////////////////////////////////
// CWordSpyDlg dialog

// Main face region
POINT	pt[15] = {{0,16},{8,161}, {262,161}, {267,14}, {262, 7}, {234,2},
	{192,0}, {135,6}, {129,10}, {125,6}, {88,1}, {90,1}, {42,0}, {9,5}, {0,12}};

//Region for close window
//CRect AddRect(240, 0, 265, 20);
//CRect CutRect(211, 120, 231, 140);
//CRect DiskRect(234, 126, 254, 146);

CWordSpyDlg::CWordSpyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWordSpyDlg::IDD, pParent),
	m_brush(RGB(255,255,128)),
	m_btnNext(IDB_NEXT, CSize(23,23))
//	m_btnCut(IDB_CUT, CSize(12, 18)),
//	m_btnDisk(IDB_DISK, CSize(14, 14))
{
	m_bAutoAddWord = 0;
	m_bFirstTime = true;
	//{{AFX_DATA_INIT(CWordSpyDlg)
	m_szEnglish = _T("");
	m_szRussian = _T("");
	m_szCount = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CWordSpyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWordSpyDlg)
	DDX_Control(pDX, IDC_NEXT, m_btnNext);
	DDX_Text(pDX, IDC_ENGLISH, m_szEnglish);
	DDX_Text(pDX, IDC_RUSSIAN, m_szRussian);
	DDV_MaxChars(pDX, m_szRussian, 100);
	DDX_Text(pDX, IDC_COUNT, m_szCount);
	DDV_MaxChars(pDX, m_szCount, 10);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWordSpyDlg, CDialog)
	//{{AFX_MSG_MAP(CWordSpyDlg)
	ON_COMMAND(ID_LAUNCH, OnLaunch)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_NCHITTEST()
	ON_WM_CTLCOLOR()
	ON_EN_SETFOCUS(IDC_RUSSIAN, OnSetfocusRussian)
	ON_WM_CLOSE()
	ON_WM_DRAWCLIPBOARD()
	ON_COMMAND(ID_AUTOADD, OnAutoadd)
	ON_WM_ACTIVATE()
	ON_WM_SETCURSOR()
	ON_WM_WINDOWPOSCHANGED()
	ON_COMMAND(ID_EXIT, OnExit)
	ON_WM_SHOWWINDOW()
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWordSpyDlg message handlers

BOOL CWordSpyDlg::OnInitDialog()
{
//	POSITION pos = m_Dict.GetStartPosition();
//	m_Dict.GetNextAssoc(pos, m_szEnglish, m_szRussian);

	CDialog::OnInitDialog();

	CString name;
	name.LoadString(IDS_MAINFRAME);
	SetWindowText(name);

//	ModifyStyle( WS_VISIBLE, 0, SWP_NOMOVE | SWP_NOSIZE);

	m_hwndNext = SetClipboardViewer();
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	CDialog::SetIcon(m_hIcon, TRUE);			// Set big icon
	CDialog::SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_bmpMain.LoadBitmap(IDB_FACE);
	m_vDC.CreateCompatibleDC(GetDC());
	m_vDC.SelectObject(m_bmpMain);

	/////////////////////////////////////////////////////////
//	m_bmpHitTest.LoadBitmap(IDB_DISK);
//	m_vHitTestDC.CreateCompatibleDC(&m_vDC);
//	m_vHitTestDC.SelectObject(m_bmpHitTest);

	m_rgnMain.CreatePolygonRgn(pt, 15, ALTERNATE);
	SetWindowRgn(m_rgnMain, false);

	HICON hIcon = AfxGetApp()->LoadIcon(IDR_TASKBAR);
	CTaskBarIcon::SetIcon(hIcon, name);

	int cx = GetSystemMetrics(SM_CXFULLSCREEN);
	int cy = GetSystemMetrics(SM_CYFULLSCREEN);
	SetWindowPos( &wndBottom, cx - 280, cy - 150, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

	// CG: The following block was added by the ToolTips component.
	{
		// Create the ToolTip control.
		m_tooltip.Create(this);
		m_tooltip.Activate(TRUE);

		// TODO: Use one of the following forms to add controls:
		// m_tooltip.AddTool(GetDlgItem(IDC_<name>), <string-table-id>);
		// m_tooltip.AddTool(GetDlgItem(IDC_<name>), "<text>");
		m_tooltip.AddTool(&m_btnNext, IDS_NEXT_PAGE);
//		m_tooltip.AddTool(&m_btnCut, ID_CUT);
//		m_tooltip.AddTool(&m_btnDisk, ID_SAVE);
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWordSpyDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // device context for painting
		dc.BitBlt(0, 0, 268, 162, &m_vDC, 0, 0, SRCCOPY);
//		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWordSpyDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

UINT CWordSpyDlg::OnNcHitTest(CPoint point) 
{
//	return CDialog::OnNcHitTest(point);
//	ScreenToClient(&point);

//	if(AddRect.PtInRect(point))
//		return HTCLIENT;
//	else {
//		GetDC()->BitBlt(228, 133, 20, 20, &m_vHitTestDC, 0, 0, SRCCOPY);
//		Invalidate();
//		m_btnCut.Fire(false);
//		m_btnDisk.Fire(false);
//		m_btnNext.Fire(false);
		return HTCAPTION;
//	}
}

HBRUSH CWordSpyDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
//	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	pDC->SetBkColor(RGB(255,255,128));	
	if( pWnd->GetDlgCtrlID() == IDC_COUNT )
		pDC->SetTextColor(RGB(192,192,192));	
	else
		pDC->SetTextColor(RGB(0,0,0));	

	// TODO: Return a different brush if the default is not desired
	return m_brush;
}

void CWordSpyDlg::OnRButtonDown() {
	CMenu menu;

	menu.LoadMenu(IDR_MAINMENU);
	POINT pnt;
	GetCursorPos(&pnt);
	SetForegroundWindow();

	if( m_bAutoAddWord )
		menu.GetSubMenu(0)->CheckMenuItem(0, MF_CHECKED | MF_BYPOSITION);
	else
		menu.GetSubMenu(0)->CheckMenuItem(0, MF_UNCHECKED | MF_BYPOSITION);

	if( Registry.GetValue(HKEY_LOCAL_MACHINE, 
		"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\Dictionary",
		"", m_szDictionaryPath))
	{
		CFileStatus fileStatus;

		if(CFile::GetStatus(m_szDictionaryPath, fileStatus))
			menu.GetSubMenu(0)->EnableMenuItem(1, MF_ENABLED | MF_BYPOSITION);
		else
			menu.GetSubMenu(0)->EnableMenuItem(1, MF_GRAYED | MF_BYPOSITION);
	}
	else
		menu.GetSubMenu(0)->EnableMenuItem(1, MF_GRAYED | MF_BYPOSITION);

	menu.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		pnt.x, pnt.y, this, NULL);

	PostMessage(WM_MOUSEMOVE, 0, 0);

}

void CWordSpyDlg::OnSetfocusRussian() 
{
	gLanguage.SetLayout(RUSSIAN_LAYOUT);	
}

void CWordSpyDlg::OnLaunch() {
	//_execl(m_szDictionaryPath, m_szDictionaryPath, NULL);
//	CreateProcess(m_szDictionaryPath, "", NULL, NULL, false, 
//		CREATE_DEFAULT_ERROR_MODE | NORMAL_PRIORITY_CLASS,
//		NULL, m_szDictionaryPath, NULL, NULL);
	//system(m_szDictionaryPath);
	_spawnl(_P_NOWAIT, m_szDictionaryPath, m_szDictionaryPath, NULL);
}

void CWordSpyDlg::OnClose() 
{
//	CDialog::OnClose();
	ShowWindow(SW_HIDE);
}

void CWordSpyDlg::OnLButtonDown()
{
	m_szCount.Format("- %d -", m_Dict.GetCount());

	int cx = GetSystemMetrics(SM_CXFULLSCREEN);
	int cy = GetSystemMetrics(SM_CYFULLSCREEN);
	SetWindowPos( &wndTopMost, cx - 280, cy - 150, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);
	SetForegroundWindow();

	UpdateData(false);
}

void CWordSpyDlg::OnDrawClipboard() 
{
	CDialog::OnDrawClipboard();
	
//	if(IsWindow(m_hNextCbChainWnd)) implementation Internet
//		::SendMessage(m_hNextCbChainWnd, WM_DRAWCLIPBOARD, 0, 0); Partial
	CString szText;

	//    Clipboard-
	if( OpenClipboard() )
	{
		HANDLE hGin = ::GetClipboardData( CF_TEXT );
		if( hGin != NULL )
		{
			//    
			LPVOID pointer = ::GlobalLock( hGin );
			
			szText = (LPCSTR) pointer;	
			szText.TrimRight(); //    

			int	first = szText[0]; //    
			szText.SetAt(0,(TCHAR) toupper( first ));

			// 
			::GlobalUnlock( hGin );

			if(!szText.IsEmpty())
			{
				if( m_Dict.Lookup(szText, m_szRussian) ) {
					m_szEnglish = szText;
					OnLButtonDown();

					UpdateData(FALSE);
				}
				else
				{
//					Registry.GetValue( ADDWORD_AUTOMATICAL, bAutoAddWord  );
					m_szEnglish = szText;
					m_szRussian = "";

					if( m_bAutoAddWord )
					{
						m_szEnglish = szText;
						m_szRussian = "";
						OnLButtonDown();
					}	
					UpdateData(FALSE);
				}
			}
		}
		CloseClipboard();
	}
}

BOOL CWordSpyDlg::DestroyWindow() 
{
	ChangeClipboardChain(m_hwndNext);
	return CDialog::DestroyWindow();
}

void CWordSpyDlg::OnAutoadd() 
{
	if( m_bAutoAddWord )
		m_bAutoAddWord = 0;
	else
		m_bAutoAddWord = 1;
}

void CWordSpyDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	if(nState == WA_INACTIVE) {
		ShowWindow(SW_HIDE);
	}
}

BOOL CWordSpyDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	switch(nHitTest) {
//		case HTCLIENT:
//			SetCursor( AfxGetApp()->LoadCursor(IDC_HAND));
//			return false;
		case HTCAPTION:
			if( message ) {
				SetCursor( AfxGetApp()->LoadStandardCursor(IDC_SIZEALL));
				return false;
			}
		default:
			return CDialog::OnSetCursor(pWnd, nHitTest, message);
	}
}

void CWordSpyDlg::OnWindowPosChanged(WINDOWPOS FAR* lpwndpos) 
{
	if( m_bFirstTime && ((lpwndpos->flags & SWP_SHOWWINDOW) == SWP_SHOWWINDOW)) {
		m_bFirstTime = false;
		lpwndpos->flags = SWP_HIDEWINDOW;
		ShowWindow(SW_HIDE);
	}
	else
		CDialog::OnWindowPosChanged(lpwndpos);
}

void CWordSpyDlg::OnExit() 
{
	CDialog::OnOK();	
}

BOOL CWordSpyDlg::PreCreateWindow(CREATESTRUCT& cs) 
{
//	cs.style &= ~WS_VISIBLE;
	return CDialog::PreCreateWindow(cs);
}

void CWordSpyDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
/*	if( m_bFirstTime ) {
		m_bFirstTime = false;
		bShow = false;
	}
*/
	CDialog::OnShowWindow(bShow, nStatus);
}

BOOL CWordSpyDlg::PreTranslateMessage(MSG* pMsg)
{
	// CG: The following block was added by the ToolTips component.
	{
		// Let the ToolTip process this message.
		m_tooltip.RelayEvent(pMsg);
	}
	return CDialog::PreTranslateMessage(pMsg);	// CG: This was added by the ToolTips component.
}

void CWordSpyDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	
	CDialog::OnMouseMove(nFlags, point);
}

void CWordSpyDlg::OnNext() 
{
	UpdateData(true);

	if( !m_szEnglish.IsEmpty() && !m_szRussian.IsEmpty() ) {
		m_Dict[m_szEnglish] = m_szRussian;
		m_szEnglish = m_szRussian = "";

		CString name;

		if(	Registry.GetValue(DEFAULT_DOCUMENT, name))
		{
			CFile file;
			if( file.Open( name, CFile::modeWrite) ) {
				CArchive ar( &file, CArchive::store);
				m_Dict.Serialize(ar);
				return;
			}
		}

		ShowWindow(SW_HIDE);
	}

	UpdateData(false);
}
