// WordSpyDlg.h : header file
//

#if !defined(AFX_WORDSPYDLG_H__A39CA507_4E3D_11D3_84F7_444553540000__INCLUDED_)
#define AFX_WORDSPYDLG_H__A39CA507_4E3D_11D3_84F7_444553540000__INCLUDED_

#include "taskbar.h"	// Added by ClassView
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CWordSpyDlg dialog
/////////////////////////////////////////////////////////////////////////////
//	  	
#define ENGLISH_LAYOUT 0
#define RUSSIAN_LAYOUT 1

struct	Language
{
	HKL	m_hRusLayout, m_hEngLayout;

	Language(void) : m_hRusLayout((HKL)0x04190419L), m_hEngLayout((HKL)0x04090409L)
	{}

	~Language(void)
	{}

	void SetLayout( UINT layoutID )
	{
		switch( layoutID )
		{
		case ENGLISH_LAYOUT:
				ActivateKeyboardLayout( m_hEngLayout, KLF_REORDER );
			break;
		case RUSSIAN_LAYOUT:
				ActivateKeyboardLayout( m_hRusLayout, KLF_REORDER );
			break;
		}
	}

} extern gLanguage;

class Dictionary: public CMapStringToString {
};

class CWordSpyDlg : public CDialog, public CTaskBarIcon
{
// Construction
public:
	CWordSpyDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CWordSpyDlg)
	enum { IDD = IDD_WORDSPY_DIALOG };
	CPictureButton	m_btnNext;
	CString	m_szEnglish;
	CString	m_szRussian;
	CString	m_szCount;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWordSpyDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:
	CToolTipCtrl m_tooltip;
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CWordSpyDlg)
	afx_msg	void OnLaunch();
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg UINT OnNcHitTest(CPoint point);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnSetfocusRussian();
	afx_msg void OnClose();
	afx_msg void OnDrawClipboard();
	afx_msg void OnAutoadd();
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnWindowPosChanged(WINDOWPOS FAR* lpwndpos);
	afx_msg void OnExit();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnNext();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CString m_szDictionaryPath;
//	CBitmap m_bmpHitTest;
	bool m_bFirstTime;
	DWORD m_bAutoAddWord;
//	CTaskBarIcon m_tbIcon;
	CBrush m_brush;
	HBRUSH m_hbrFace;
	CBitmap m_bmpMain;
	CRgn m_rgnMain;
	CDC m_vDC;
//	CDC m_vHitTestDC;
	HWND m_hwndNext;

	virtual void OnRButtonDown();
	virtual void OnLButtonDown();

public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
		Dictionary	m_Dict;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WORDSPYDLG_H__A39CA507_4E3D_11D3_84F7_444553540000__INCLUDED_)
